"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDirectory = void 0;
const path_1 = require("path");
const fs_1 = require("fs");
const opLog_1 = require("../opLog/opLog");
function getDirectory(dir, exitIfNotExists = true) {
    const opLog = opLog_1.getOpLog();
    let directory = path_1.resolve(dir);
    try {
        if (!fs_1.lstatSync(directory).isDirectory()) {
            const splittedDir = directory.split(path_1.sep);
            splittedDir.pop();
            directory = splittedDir.join(path_1.sep);
            if (process.platform === "win32") {
                directory = directory.replace(/\\/g, "/");
            }
            return directory;
        }
        else {
            if (process.platform === "win32") {
                directory = directory.replace(/\\/g, "/");
            }
            return directory;
        }
    }
    catch (e) {
        if (exitIfNotExists) {
            opLog.error("invalid directory", directory);
            return process.exit(1);
        }
        else {
            return directory;
        }
    }
}
exports.getDirectory = getDirectory;
