"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareFromJson = void 0;
const opLog_1 = require("../opLog/opLog");
const getDirectory_1 = require("./getDirectory");
function prepareFromJson(dir, jsonConfig) {
    const opLog = opLog_1.getOpLog();
    const directory = getDirectory_1.getDirectory(dir);
    process.chdir(directory);
    opLog.info("running project:", directory);
    opLog.info("configFile: from json");
    try {
        return {
            config: JSON.parse(isBase64(jsonConfig) ? Buffer.from(jsonConfig, "base64").toString("utf8") : jsonConfig),
            directory: directory
        };
    }
    catch (_e) {
        opLog.error("Invalid json passed to --jsonConfig");
        return process.exit(1);
    }
}
exports.prepareFromJson = prepareFromJson;
function isBase64(str) {
    return Buffer.from(str, "base64").toString("base64") === str;
}
