"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getName = void 0;
const prompts_1 = __importDefault(require("prompts"));
const lodash_1 = require("lodash");
const opLog_1 = require("../../opLog/opLog");
const opLog = opLog_1.getOpLog();
function getName(name, typeForQuestion) {
    return __awaiter(this, void 0, void 0, function* () {
        if (name && typeof name === "string") {
            return name;
        }
        else {
            const response = yield prompts_1.default({
                type: "text",
                name: "answer",
                message: `Enter a name for the new ${typeForQuestion}`
            });
            if (!response.answer) {
                opLog.error(`Enter a name for the new ${typeForQuestion} to continue`);
                process.exit(1);
            }
            return lodash_1.camelCase(response.answer.replace(/[.]js|[.]ts/, ""));
        }
    });
}
exports.getName = getName;
