"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(ayakashiInstance) {
    ayakashiInstance.registerAction("click", function (prop) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<click> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<click> needs a prop with at least 1 match");
            yield this.scrollIntoView(myProp);
            const pos = yield this.getPosition(myProp);
            return this.__connection.mouse.click(pos.x, pos.y);
        });
    });
    ayakashiInstance.registerAction("doubleClick", function (prop) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<doubleClick> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<doubleClick> needs a prop with at least 1 match");
            yield this.scrollIntoView(myProp);
            const pos = yield this.getPosition(myProp);
            return this.__connection.mouse.click(pos.x, pos.y, { clickCount: 2 });
        });
    });
    ayakashiInstance.registerAction("rightClick", function (prop) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<rightClick> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<rightClick> needs a prop with at least 1 match");
            yield this.scrollIntoView(myProp);
            const pos = yield this.getPosition(myProp);
            return this.__connection.mouse.click(pos.x, pos.y, { button: "right" });
        });
    });
    ayakashiInstance.registerAction("tap", function (prop) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<tap> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<tap> needs a prop with at least 1 match");
            yield this.scrollIntoView(myProp);
            const pos = yield this.getPosition(myProp);
            return this.__connection.touchScreen.tap(pos.x, pos.y);
        });
    });
}
exports.default = default_1;
