"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function default_1(ayakashiInstance) {
    ayakashiInstance.registerAction("typeIn", function (prop, text) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<typeIn> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<typeIn> needs a prop with at least 1 match");
            if (!text)
                throw new Error("<typeIn> needs some text to type");
            yield this.scrollIntoView(myProp);
            yield this.focus(myProp);
            return this.__connection.keyBoard.type(text, { delay: 100 });
        });
    });
    ayakashiInstance.registerAction("clearInput", function (prop, charCount) {
        return __awaiter(this, void 0, void 0, function* () {
            const myProp = this.prop(prop);
            if (!myProp)
                throw new Error("<clearInput> needs a valid prop");
            const matchCount = yield myProp.trigger();
            if (matchCount === 0)
                throw new Error("<clearInput> needs a prop with at least 1 match");
            const valLength = charCount ? charCount : (yield this.evaluate(function (scopedPropId) {
                const node = this.propTable[scopedPropId].matches[0];
                return node.value || "";
            }, myProp.id)).length;
            yield this.scrollIntoView(myProp);
            yield this.focus(myProp);
            for (let i = 0; i < valLength; i += 1) {
                yield this.__connection.keyBoard.press("Backspace", { delay: 100 });
            }
        });
    });
}
exports.default = default_1;
